package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.writer.GetFileErrorRule;
import lightcontainer.storage.File;

public class GetFileRule extends ProtocolReader {
    // Constants
    private static final String PATTERN = "^GETFILE ([^ !]{1,20})\r\n$";
    private static final String NAME = "GETFILE";
    // -- arguments
    private static final int FILE_NAME = 0; // Index file name.

    // Variables
    private final ProtocolRepository protocolRep;

    // Constructor
    public GetFileRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    /**
     * Rule Result
     */
    public class Result extends ProtocolResult {
        // Variables
        private final String fileName;

        // Constructor
        public Result(Context context, String fileName) {
            super(context);
            this.fileName = fileName;
        }

    }

    /**
     * Cette méthode est appelée lors de l'exécution de la règle
     *
     * @param context Utilisateur context.
     * @param data    Paramètres pour créer la commande.
     */
    @Override
    protected GetFileRule.Result onExecuted(Context context, String... data) {
        GetFileRule.Result result = new GetFileRule.Result(context, data[FILE_NAME]);

        File file = context.getFileOf(data[FILE_NAME], context.getLogin());

        if (true) {

        } else {

        }

        return result;
    }

    /**
     * Cette méthode est appelée lors d'une erreur de la règle
     */
    protected ProtocolReader.ProtocolResult onError(Context context) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        // Make getFileErrorRule
        result.setResultCommand(protocolRep.executeWriter(context, GetFileErrorRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }
}
