package lightcontainer.storage;

import java.util.Iterator;
import java.util.Set;

/**
 * File represents all information related to a file
 */
public class File {
    // Variables
    private final String name;
    private final String fileNameSalt;
    private final int size;
    private final String iv;
    private final Set<String> storage;

    // Constructor
    public File(String name, String fileNameSalt, int size, String iv, Set<String> storage) {
        this.name = name;
        this.fileNameSalt = fileNameSalt;
        this.size = size;
        this.iv = iv;
        this.storage = storage;
    }

    public String getName() {
        return name;
    }

    public String getFileNameSalt() {
        return fileNameSalt;
    }

    public int getSize() {
        return size;
    }

    public String getIv() {
        return iv;
    }

    public Iterator<String> getStorageIterator() {
        return storage.iterator();
    }

    public boolean addStorage(String storage) {
        if (this.storage.contains(storage)) {
            return false;
        } else {
            this.storage.add(storage);
            return true;
        }
    }
}

